#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/file.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <string.h>
#include <stdarg.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <signal.h>
#include <sys/wait.h>
#include <regex.h> 
 
struct rtp_header{  
    unsigned char cc:4;  
    unsigned char x:1;  
    unsigned char p:1;  
    unsigned char v:2;       
    unsigned char pt:7;  
    unsigned char m:1;  
    unsigned short sequence_number;  
    unsigned int timestamp;  
    unsigned int ssrc;  
};  
 
void main(int argc, char **argv)  
{   
    int socka;       
    int nPortA = 8000;  
    fd_set rfd;
    struct timeval timeout;
    struct sockaddr_in addr;
    char recv_buf[1500];
      
    int nRecLen;
      
    struct sockaddr_in cli;
    int nRet;
 
    socka = socket(AF_INET, SOCK_DGRAM, 0); 
    if (socka == -1)  
    {  
        printf("socket()/n");  
        return;  
    }  
 
    memset(&addr, 0, sizeof(addr));  
      
    addr.sin_family = AF_INET;
    addr.sin_port = htons(nPortA);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    if (bind(socka, (struct sockaddr*)&addr, sizeof(addr)) == -1)
    {  
        printf("bind()/n");  
        return;  
    }  
       
    //timeout = 6s 
    timeout.tv_sec = 6;   
    timeout.tv_usec = 0;  
      
    memset(recv_buf, 0, sizeof(recv_buf)); 

	FILE *fp_write = fopen("out.ts", "wb+");

    while (1)  
    {  
        FD_ZERO(&rfd); 
          
        FD_SET(socka, &rfd);
  
          
        nRet = select(socka+1, &rfd, NULL, NULL, &timeout);
        if (nRet == -1)     
        {  
            printf("select()\n");  
            return;  
        }  
        else if (nRet == 0)
        {  
            //printf("timeout\n");  
			continue; 
        }  
        else
        {  
            if (FD_ISSET(socka, &rfd))
            {  
                nRecLen = sizeof(cli);  
                int nRecEcho = recvfrom(socka, recv_buf, sizeof(recv_buf), 0, (struct sockaddr*)&cli, &nRecLen);  
                if (nRecEcho == -1)  
                {  
                    printf("recvfrom()\n");  
                    break;  
                }
				
                struct rtp_header *p = (struct rtp_header *)recv_buf;
				printf("v = %d\n",p->v);
				printf("p = %d\n",p->p);
				printf("x = %d\n",p->x);
				printf("cc = %d\n",p->cc);
				printf("sequence_number = %d\n",ntohs(p->sequence_number));
				printf("ssrc = %d\n",ntohs(p->ssrc));

				if (!feof(fp_write)) {
					fwrite(recv_buf, 1, nRecEcho, fp_write);
				}
            }  
 
        }  
    }  
}  
